using Microsoft.Scripting;
using Microsoft.Scripting.Ast;

namespace MyL.Parser.AST {

	class MyLPrint : MyLStatement {

		private readonly MyLExpression _expression;

		public MyLPrint(SourceSpan span, MyLExpression expression) :base(span) {
			_expression = expression;
		}

		protected internal override Expression Generate(MyLLanguageContext context) {
			
			return ReturnStatement.Return (Utils.Call(
				typeof(MyLHelpers).GetMethod("Print"),
				Span,
				Expression.ConvertHelper(_expression.Generate(context), typeof(object))
			));
		}
	}
}
