// $ANTLR 3.1b2 MyLTree.g 2008-08-09 15:37:20
namespace  MyL.Parser.AST 
{
   
    // turn of unreachable code warnings
    // turn off obsolete code warnings
    // turn off unused variable
    # pragma warning disable 0162,0618,0219 
	using Microsoft.Scripting;


using System;
using Antlr.Runtime;
using Antlr.Runtime.Debug;
using Antlr.Runtime.Tree;using IList 		= System.Collections.IList;
using ArrayList 	= System.Collections.ArrayList;
using Stack 		= Antlr.Runtime.Collections.StackList;



public class MyLTree : TreeParser 
{
    public static readonly string[] tokenNames = new string[] 
	{
        "<invalid>", 
		"<EOR>", 
		"<DOWN>", 
		"<UP>", 
		"PLUS", 
		"MINUS", 
		"MULTIPLY", 
		"DIVIDE", 
		"UNARY_PLUS", 
		"UNARY_MINUS", 
		"NEWLINE", 
		"IDENTIFIER", 
		"ASSIGN", 
		"NUMBER", 
		"LPAREN", 
		"RPAREN", 
		"WS", 
		"LCLETTER", 
		"DIGIT", 
		"INT", 
		"FLOAT"
    };

    public const int NUMBER = 13;
    public const int UNARY_MINUS = 9;
    public const int INT = 19;
    public const int FLOAT = 20;
    public const int MINUS = 5;
    public const int EOF = -1;
    public const int UNARY_PLUS = 8;
    public const int LPAREN = 14;
    public const int RPAREN = 15;
    public const int WS = 16;
    public const int NEWLINE = 10;
    public const int MULTIPLY = 6;
    public const int IDENTIFIER = 11;
    public const int ASSIGN = 12;
    public const int PLUS = 4;
    public const int DIGIT = 18;
    public const int DIVIDE = 7;
    public const int LCLETTER = 17;

    // delegates
    // delegators



        public MyLTree(ITreeNodeStream input)
    		: this(input, new RecognizerSharedState()) {
        }

        public MyLTree(ITreeNodeStream input, RecognizerSharedState state)
    		: base(input, state) {
    		InitializeCyclicDFAs();
             
       }
        
    protected ITreeAdaptor adaptor = new CommonTreeAdaptor();

    public ITreeAdaptor TreeAdaptor
    {
        get { return this.adaptor; }
        set { this.adaptor = value; }
    }

    override public string[] TokenNames {
		get { return MyLTree.tokenNames; }
    }

    override public string GrammarFileName {
		get { return "MyLTree.g"; }
    }


    public class program_return : TreeRuleReturnScope
    {
        public MyLStatement result;
        private CommonTree tree;
        override public object Tree
        {
        	get { return tree; }
        	set { tree = (CommonTree) value; }
        }
    };

    // $ANTLR start "program"
    // MyLTree.g:31:1: program returns [MyLStatement result] : (e= expr | ^( ASSIGN lvalue= IDENTIFIER rvalue= expr ) );
    public MyLTree.program_return program() // throws RecognitionException [1]
    {   
        MyLTree.program_return retval = new MyLTree.program_return();
        retval.Start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree lvalue = null;
        CommonTree ASSIGN1 = null;
        MyLTree.expr_return e = null;

        MyLTree.expr_return rvalue = null;


        CommonTree lvalue_tree=null;
        CommonTree ASSIGN1_tree=null;

        try 
    	{
            // MyLTree.g:32:2: (e= expr | ^( ASSIGN lvalue= IDENTIFIER rvalue= expr ) )
            int alt1 = 2;
            int LA1_0 = input.LA(1);

            if ( ((LA1_0 >= PLUS && LA1_0 <= UNARY_MINUS) || LA1_0 == IDENTIFIER || LA1_0 == NUMBER) )
            {
                alt1 = 1;
            }
            else if ( (LA1_0 == ASSIGN) )
            {
                alt1 = 2;
            }
            else 
            {
                NoViableAltException nvae_d1s0 =
                    new NoViableAltException("", 1, 0, input);

                throw nvae_d1s0;
            }
            switch (alt1) 
            {
                case 1 :
                    // MyLTree.g:32:4: e= expr
                    {
                    	root_0 = (CommonTree)adaptor.GetNilNode();

                    	_last = (CommonTree)input.LT(1);
                    	PushFollow(FOLLOW_expr_in_program73);
                    	e = expr();
                    	state.followingStackPointer--;

                    	adaptor.AddChild(root_0, e.Tree);
                    	retval.result =  new MyLPrint(new SourceSpan(), ((e != null) ? e.result : null));

                    }
                    break;
                case 2 :
                    // MyLTree.g:33:4: ^( ASSIGN lvalue= IDENTIFIER rvalue= expr )
                    {
                    	root_0 = (CommonTree)adaptor.GetNilNode();

                    	_last = (CommonTree)input.LT(1);
                    	{
                    	CommonTree _save_last_1 = _last;
                    	CommonTree _first_1 = null;
                    	CommonTree root_1 = (CommonTree)adaptor.GetNilNode();_last = (CommonTree)input.LT(1);
                    	ASSIGN1=(CommonTree)Match(input,ASSIGN,FOLLOW_ASSIGN_in_program82); 
                    		ASSIGN1_tree = (CommonTree)adaptor.DupNode(ASSIGN1);

                    		root_1 = (CommonTree)adaptor.BecomeRoot(ASSIGN1_tree, root_1);



                    	Match(input, Token.DOWN, null); 
                    	_last = (CommonTree)input.LT(1);
                    	lvalue=(CommonTree)Match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_program86); 
                    		lvalue_tree = (CommonTree)adaptor.DupNode(lvalue);

                    		adaptor.AddChild(root_1, lvalue_tree);

                    	_last = (CommonTree)input.LT(1);
                    	PushFollow(FOLLOW_expr_in_program90);
                    	rvalue = expr();
                    	state.followingStackPointer--;

                    	adaptor.AddChild(root_1, rvalue.Tree);

                    	Match(input, Token.UP, null); adaptor.AddChild(root_0, root_1);_last = _save_last_1;
                    	}


                    				MyLIdentifier id;
                    				MyLAssign assign;
                    				
                    				id = new MyLIdentifier(new SourceSpan(), lvalue.Text);
                    				assign = new MyLAssign(new SourceSpan(), id, ((rvalue != null) ? rvalue.result : null));
                    				retval.result =  new MyLPrint(new SourceSpan(), assign);
                    				

                    }
                    break;

            }
            	retval.Tree = (CommonTree)adaptor.RulePostProcessing(root_0);

        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end "program"

    public class expr_return : TreeRuleReturnScope
    {
        public MyLExpression result;
        private CommonTree tree;
        override public object Tree
        {
        	get { return tree; }
        	set { tree = (CommonTree) value; }
        }
    };

    // $ANTLR start "expr"
    // MyLTree.g:43:1: expr returns [MyLExpression result] : ( ^(op= ( PLUS | MINUS | MULTIPLY | DIVIDE ) left= expr right= expr ) | ^(op= ( UNARY_PLUS | UNARY_MINUS ) arg= expr ) | id= IDENTIFIER | n= NUMBER );
    public MyLTree.expr_return expr() // throws RecognitionException [1]
    {   
        MyLTree.expr_return retval = new MyLTree.expr_return();
        retval.Start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree op = null;
        CommonTree id = null;
        CommonTree n = null;
        MyLTree.expr_return left = null;

        MyLTree.expr_return right = null;

        MyLTree.expr_return arg = null;


        CommonTree op_tree=null;
        CommonTree id_tree=null;
        CommonTree n_tree=null;

        try 
    	{
            // MyLTree.g:44:2: ( ^(op= ( PLUS | MINUS | MULTIPLY | DIVIDE ) left= expr right= expr ) | ^(op= ( UNARY_PLUS | UNARY_MINUS ) arg= expr ) | id= IDENTIFIER | n= NUMBER )
            int alt2 = 4;
            switch ( input.LA(1) ) 
            {
            case PLUS:
            case MINUS:
            case MULTIPLY:
            case DIVIDE:
            	{
                alt2 = 1;
                }
                break;
            case UNARY_PLUS:
            case UNARY_MINUS:
            	{
                alt2 = 2;
                }
                break;
            case IDENTIFIER:
            	{
                alt2 = 3;
                }
                break;
            case NUMBER:
            	{
                alt2 = 4;
                }
                break;
            	default:
            	    NoViableAltException nvae_d2s0 =
            	        new NoViableAltException("", 2, 0, input);

            	    throw nvae_d2s0;
            }

            switch (alt2) 
            {
                case 1 :
                    // MyLTree.g:44:4: ^(op= ( PLUS | MINUS | MULTIPLY | DIVIDE ) left= expr right= expr )
                    {
                    	root_0 = (CommonTree)adaptor.GetNilNode();

                    	_last = (CommonTree)input.LT(1);
                    	{
                    	CommonTree _save_last_1 = _last;
                    	CommonTree _first_1 = null;
                    	CommonTree root_1 = (CommonTree)adaptor.GetNilNode();op = (CommonTree)input.LT(1);
                    	if ( (input.LA(1) >= PLUS && input.LA(1) <= DIVIDE) ) 
                    	{
                    	    input.Consume();

                    	    op_tree = (CommonTree)adaptor.DupNode(op);

                    	    root_1 = (CommonTree)adaptor.BecomeRoot(op_tree, root_1);

                    	    state.errorRecovery = false;
                    	}
                    	else 
                    	{
                    	    MismatchedSetException mse = new MismatchedSetException(null,input);
                    	    throw mse;
                    	}



                    	Match(input, Token.DOWN, null); 
                    	_last = (CommonTree)input.LT(1);
                    	PushFollow(FOLLOW_expr_in_expr123);
                    	left = expr();
                    	state.followingStackPointer--;

                    	adaptor.AddChild(root_1, left.Tree);
                    	_last = (CommonTree)input.LT(1);
                    	PushFollow(FOLLOW_expr_in_expr127);
                    	right = expr();
                    	state.followingStackPointer--;

                    	adaptor.AddChild(root_1, right.Tree);

                    	Match(input, Token.UP, null); adaptor.AddChild(root_0, root_1);_last = _save_last_1;
                    	}

                    	retval.result =  new MyLBinary(new SourceSpan(), op.Token.Type, ((left != null) ? left.result : null), ((right != null) ? right.result : null));

                    }
                    break;
                case 2 :
                    // MyLTree.g:45:4: ^(op= ( UNARY_PLUS | UNARY_MINUS ) arg= expr )
                    {
                    	root_0 = (CommonTree)adaptor.GetNilNode();

                    	_last = (CommonTree)input.LT(1);
                    	{
                    	CommonTree _save_last_1 = _last;
                    	CommonTree _first_1 = null;
                    	CommonTree root_1 = (CommonTree)adaptor.GetNilNode();op = (CommonTree)input.LT(1);
                    	if ( (input.LA(1) >= UNARY_PLUS && input.LA(1) <= UNARY_MINUS) ) 
                    	{
                    	    input.Consume();

                    	    op_tree = (CommonTree)adaptor.DupNode(op);

                    	    root_1 = (CommonTree)adaptor.BecomeRoot(op_tree, root_1);

                    	    state.errorRecovery = false;
                    	}
                    	else 
                    	{
                    	    MismatchedSetException mse = new MismatchedSetException(null,input);
                    	    throw mse;
                    	}



                    	Match(input, Token.DOWN, null); 
                    	_last = (CommonTree)input.LT(1);
                    	PushFollow(FOLLOW_expr_in_expr146);
                    	arg = expr();
                    	state.followingStackPointer--;

                    	adaptor.AddChild(root_1, arg.Tree);

                    	Match(input, Token.UP, null); adaptor.AddChild(root_0, root_1);_last = _save_last_1;
                    	}

                    	retval.result =  new MyLUnary(new SourceSpan(), op.Token.Type, ((arg != null) ? arg.result : null));

                    }
                    break;
                case 3 :
                    // MyLTree.g:46:4: id= IDENTIFIER
                    {
                    	root_0 = (CommonTree)adaptor.GetNilNode();

                    	_last = (CommonTree)input.LT(1);
                    	id=(CommonTree)Match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_expr156); 
                    		id_tree = (CommonTree)adaptor.DupNode(id);

                    		adaptor.AddChild(root_0, id_tree);

                    	retval.result =  new MyLIdentifier(new SourceSpan(), id.Text);

                    }
                    break;
                case 4 :
                    // MyLTree.g:47:4: n= NUMBER
                    {
                    	root_0 = (CommonTree)adaptor.GetNilNode();

                    	_last = (CommonTree)input.LT(1);
                    	n=(CommonTree)Match(input,NUMBER,FOLLOW_NUMBER_in_expr165); 
                    		n_tree = (CommonTree)adaptor.DupNode(n);

                    		adaptor.AddChild(root_0, n_tree);

                    	retval.result =  new MyLConstant(new SourceSpan(), double.Parse(n.Text));

                    }
                    break;

            }
            	retval.Tree = (CommonTree)adaptor.RulePostProcessing(root_0);

        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end "expr"

    // Delegated rules


	private void InitializeCyclicDFAs()
	{
	}

 

    public static readonly BitSet FOLLOW_expr_in_program73 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_ASSIGN_in_program82 = new BitSet(new ulong[]{0x0000000000000004UL});
    public static readonly BitSet FOLLOW_IDENTIFIER_in_program86 = new BitSet(new ulong[]{0x0000000000002BF0UL});
    public static readonly BitSet FOLLOW_expr_in_program90 = new BitSet(new ulong[]{0x0000000000000008UL});
    public static readonly BitSet FOLLOW_set_in_expr111 = new BitSet(new ulong[]{0x0000000000000004UL});
    public static readonly BitSet FOLLOW_expr_in_expr123 = new BitSet(new ulong[]{0x0000000000002BF0UL});
    public static readonly BitSet FOLLOW_expr_in_expr127 = new BitSet(new ulong[]{0x0000000000000008UL});
    public static readonly BitSet FOLLOW_set_in_expr138 = new BitSet(new ulong[]{0x0000000000000004UL});
    public static readonly BitSet FOLLOW_expr_in_expr146 = new BitSet(new ulong[]{0x0000000000000008UL});
    public static readonly BitSet FOLLOW_IDENTIFIER_in_expr156 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_NUMBER_in_expr165 = new BitSet(new ulong[]{0x0000000000000002UL});

}
}