using System;
using Microsoft.Scripting.Actions;
using Microsoft.Scripting.Ast;
using Microsoft.Scripting.Generation;
using Microsoft.Scripting.Runtime;

namespace MyL.Runtime {

	class MyLBinder : DefaultBinder {

        public MyLBinder(ScriptDomainManager manager)
			: base(manager) {
        }

		#region ActionBinder overrides

		protected override RuleBuilder<T> MakeRule<T> (DynamicAction action, object[] args) {
			return base.MakeRule<T>(action, args);
		}

		public override bool CanConvertFrom(Type fromType, Type toType, NarrowingLevel level) {
			return toType.IsAssignableFrom(fromType);
		}

		public override bool PreferConvert(Type t1, Type t2) {
			throw new NotImplementedException();
		}

		public override Expression ConvertExpression(Expression expr, Type toType, Expression context) {
			return Expression.ConvertHelper(expr, toType);
		}

		#endregion
	}
}