using System;
using Microsoft.Scripting.Hosting;
using Microsoft.Scripting.Hosting.Shell;

namespace MyL {

	internal sealed class MyLConsoleHost : ConsoleHost {

		protected override ScriptEngine CreateEngine () {
			Runtime.LoadAssembly(typeof(string).Assembly);
			return Runtime.GetEngine(typeof(MyLLanguageContext));
		}

		[STAThread]
		static int Main(string[] args) {
			new MyLConsoleHost().Run(args);
			return 0;
		}
	}

}
