using Microsoft.Scripting;
using Microsoft.Scripting.Ast;

namespace MyL.Parser.AST {

	class MyLConstant : MyLExpression {

		private readonly object _value;

		public MyLConstant(SourceSpan span, object value)
			: base(span) {
			_value = value;
		}

		protected internal override Expression Generate (MyLLanguageContext context) {
			return Expression.Constant(_value);
		}
	}
}
