using Microsoft.Scripting;
using Microsoft.Scripting.Ast;

namespace MyL.Parser.AST {

	public abstract class MyLExpression : MyLNode {

		protected MyLExpression(SourceSpan span)
			: base(span) {
		}

		internal protected abstract Expression Generate (MyLLanguageContext context);

		internal protected virtual Expression GenerateAssign(Expression right) {
			throw new System.InvalidOperationException("Assignment to non-lvalue");
		}
	}
}
