using Microsoft.Scripting;
using Microsoft.Scripting.Ast;

namespace MyL.Parser.AST {

	public abstract class MyLStatement : MyLNode {

		MyLLanguageContext _context;
		internal MyLLanguageContext Context {
			get { return _context; }
			set { _context = value; }
		}

		protected MyLStatement(SourceSpan span):base(span) {}

		internal protected abstract Expression Generate(MyLLanguageContext context);
	}
}
