// $ANTLR 3.1b2 MyL.g 2008-08-09 12:28:30
namespace  MyL.Parser.AST 
{

    // turn of unreachable code warnings
    // turn off obsolete code warnings
    // turn off unused variable
    # pragma warning disable 0162,0618,0219 
	using System.Text;


using System;
using Antlr.Runtime;
using Antlr.Runtime.Debug;
using IList 		= System.Collections.IList;
using ArrayList 	= System.Collections.ArrayList;
using Stack 		= Antlr.Runtime.Collections.StackList;



using Antlr.Runtime.Tree;

public class MyLParser : Parser 
{
    public static readonly string[] tokenNames = new string[] 
	{
        "<invalid>", 
		"<EOR>", 
		"<DOWN>", 
		"<UP>", 
		"PLUS", 
		"MINUS", 
		"MULTIPLY", 
		"DIVIDE", 
		"UNARY_PLUS", 
		"UNARY_MINUS", 
		"NEWLINE", 
		"IDENTIFIER", 
		"ASSIGN", 
		"NUMBER", 
		"LPAREN", 
		"RPAREN", 
		"WS", 
		"LCLETTER", 
		"DIGIT", 
		"INT", 
		"FLOAT"
    };

    public const int NUMBER = 13;
    public const int UNARY_MINUS = 9;
    public const int FLOAT = 20;
    public const int INT = 19;
    public const int MINUS = 5;
    public const int EOF = -1;
    public const int UNARY_PLUS = 8;
    public const int LPAREN = 14;
    public const int RPAREN = 15;
    public const int WS = 16;
    public const int NEWLINE = 10;
    public const int MULTIPLY = 6;
    public const int IDENTIFIER = 11;
    public const int ASSIGN = 12;
    public const int PLUS = 4;
    public const int DIGIT = 18;
    public const int DIVIDE = 7;
    public const int LCLETTER = 17;

    // delegates
    // delegators



        public MyLParser(ITokenStream input)
    		: this(input, new RecognizerSharedState()) {
        }

        public MyLParser(ITokenStream input, RecognizerSharedState state)
    		: base(input, state) {
    		InitializeCyclicDFAs();
             
       }
        
    protected ITreeAdaptor adaptor = new CommonTreeAdaptor();

    public ITreeAdaptor TreeAdaptor
    {
        get { return this.adaptor; }
        set { this.adaptor = value; }
    }

    override public string[] TokenNames {
		get { return MyLParser.tokenNames; }
    }

    override public string GrammarFileName {
		get { return "MyL.g"; }
    }


    public class program_return : ParserRuleReturnScope
    {
        private CommonTree tree;
        override public object Tree
        {
        	get { return tree; }
        	set { tree = (CommonTree) value; }
        }
    };

    // $ANTLR start "program"
    // MyL.g:46:1: program : expr NEWLINE EOF ;
    public MyLParser.program_return program() // throws RecognitionException [1]
    {   
        MyLParser.program_return retval = new MyLParser.program_return();
        retval.Start = input.LT(1);

        CommonTree root_0 = null;

        IToken NEWLINE2 = null;
        IToken EOF3 = null;
        MyLParser.expr_return expr1 = null;


        CommonTree NEWLINE2_tree=null;
        CommonTree EOF3_tree=null;

        try 
    	{
            // MyL.g:46:10: ( expr NEWLINE EOF )
            // MyL.g:46:12: expr NEWLINE EOF
            {
            	root_0 = (CommonTree)adaptor.GetNilNode();

            	PushFollow(FOLLOW_expr_in_program120);
            	expr1 = expr();
            	state.followingStackPointer--;

            	adaptor.AddChild(root_0, expr1.Tree);
            	NEWLINE2=(IToken)Match(input,NEWLINE,FOLLOW_NEWLINE_in_program122); 
            	EOF3=(IToken)Match(input,EOF,FOLLOW_EOF_in_program125); 

            }

            retval.Stop = input.LT(-1);

            	retval.Tree = (CommonTree)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, (IToken) retval.Start, (IToken) retval.Stop);
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
    	// Conversion of the second argument necessary, but harmless
    	retval.Tree = (CommonTree)adaptor.ErrorNode(input, (IToken) retval.Start, input.LT(-1), re);

        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end "program"

    public class expr_return : ParserRuleReturnScope
    {
        private CommonTree tree;
        override public object Tree
        {
        	get { return tree; }
        	set { tree = (CommonTree) value; }
        }
    };

    // $ANTLR start "expr"
    // MyL.g:49:1: expr : ( multExpr ( ( PLUS | MINUS ) multExpr )* | IDENTIFIER ASSIGN expr -> ^( ASSIGN IDENTIFIER expr ) );
    public MyLParser.expr_return expr() // throws RecognitionException [1]
    {   
        MyLParser.expr_return retval = new MyLParser.expr_return();
        retval.Start = input.LT(1);

        CommonTree root_0 = null;

        IToken set5 = null;
        IToken IDENTIFIER7 = null;
        IToken ASSIGN8 = null;
        MyLParser.multExpr_return multExpr4 = null;

        MyLParser.multExpr_return multExpr6 = null;

        MyLParser.expr_return expr9 = null;


        CommonTree set5_tree=null;
        CommonTree IDENTIFIER7_tree=null;
        CommonTree ASSIGN8_tree=null;
        RewriteRuleTokenStream stream_IDENTIFIER = new RewriteRuleTokenStream(adaptor,"token IDENTIFIER");
        RewriteRuleTokenStream stream_ASSIGN = new RewriteRuleTokenStream(adaptor,"token ASSIGN");
        RewriteRuleSubtreeStream stream_expr = new RewriteRuleSubtreeStream(adaptor,"rule expr");
        try 
    	{
            // MyL.g:49:7: ( multExpr ( ( PLUS | MINUS ) multExpr )* | IDENTIFIER ASSIGN expr -> ^( ASSIGN IDENTIFIER expr ) )
            int alt2 = 2;
            int LA2_0 = input.LA(1);

            if ( ((LA2_0 >= PLUS && LA2_0 <= MINUS) || (LA2_0 >= NUMBER && LA2_0 <= LPAREN)) )
            {
                alt2 = 1;
            }
            else if ( (LA2_0 == IDENTIFIER) )
            {
                int LA2_2 = input.LA(2);

                if ( (LA2_2 == ASSIGN) )
                {
                    alt2 = 2;
                }
                else if ( ((LA2_2 >= PLUS && LA2_2 <= DIVIDE) || LA2_2 == NEWLINE || LA2_2 == RPAREN) )
                {
                    alt2 = 1;
                }
                else 
                {
                    NoViableAltException nvae_d2s2 =
                        new NoViableAltException("", 2, 2, input);

                    throw nvae_d2s2;
                }
            }
            else 
            {
                NoViableAltException nvae_d2s0 =
                    new NoViableAltException("", 2, 0, input);

                throw nvae_d2s0;
            }
            switch (alt2) 
            {
                case 1 :
                    // MyL.g:49:9: multExpr ( ( PLUS | MINUS ) multExpr )*
                    {
                    	root_0 = (CommonTree)adaptor.GetNilNode();

                    	PushFollow(FOLLOW_multExpr_in_expr140);
                    	multExpr4 = multExpr();
                    	state.followingStackPointer--;

                    	adaptor.AddChild(root_0, multExpr4.Tree);
                    	// MyL.g:49:18: ( ( PLUS | MINUS ) multExpr )*
                    	do 
                    	{
                    	    int alt1 = 2;
                    	    int LA1_0 = input.LA(1);

                    	    if ( ((LA1_0 >= PLUS && LA1_0 <= MINUS)) )
                    	    {
                    	        alt1 = 1;
                    	    }


                    	    switch (alt1) 
                    		{
                    			case 1 :
                    			    // MyL.g:49:19: ( PLUS | MINUS ) multExpr
                    			    {
                    			    	set5=(IToken)input.LT(1);
                    			    	set5 = (IToken)input.LT(1);
                    			    	if ( (input.LA(1) >= PLUS && input.LA(1) <= MINUS) ) 
                    			    	{
                    			    	    input.Consume();
                    			    	    root_0 = (CommonTree)adaptor.BecomeRoot((CommonTree)adaptor.Create(set5), root_0);
                    			    	    state.errorRecovery = false;
                    			    	}
                    			    	else 
                    			    	{
                    			    	    MismatchedSetException mse = new MismatchedSetException(null,input);
                    			    	    throw mse;
                    			    	}

                    			    	PushFollow(FOLLOW_multExpr_in_expr150);
                    			    	multExpr6 = multExpr();
                    			    	state.followingStackPointer--;

                    			    	adaptor.AddChild(root_0, multExpr6.Tree);

                    			    }
                    			    break;

                    			default:
                    			    goto loop1;
                    	    }
                    	} while (true);

                    	loop1:
                    		;	// Stops C# compiler whining that label 'loop1' has no statements


                    }
                    break;
                case 2 :
                    // MyL.g:50:6: IDENTIFIER ASSIGN expr
                    {
                    	IDENTIFIER7=(IToken)Match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_expr159);  
                    	stream_IDENTIFIER.Add(IDENTIFIER7);

                    	ASSIGN8=(IToken)Match(input,ASSIGN,FOLLOW_ASSIGN_in_expr161);  
                    	stream_ASSIGN.Add(ASSIGN8);

                    	PushFollow(FOLLOW_expr_in_expr163);
                    	expr9 = expr();
                    	state.followingStackPointer--;

                    	stream_expr.Add(expr9.Tree);


                    	// AST REWRITE
                    	// elements:          expr, IDENTIFIER, ASSIGN
                    	// token labels:      
                    	// rule labels:       retval
                    	// token list labels: 
                    	// rule list labels:  
                    	retval.Tree = root_0;
                    	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));

                    	root_0 = (CommonTree)adaptor.GetNilNode();
                    	// 50:29: -> ^( ASSIGN IDENTIFIER expr )
                    	{
                    	    // MyL.g:50:32: ^( ASSIGN IDENTIFIER expr )
                    	    {
                    	    CommonTree root_1 = (CommonTree)adaptor.GetNilNode();
                    	    root_1 = (CommonTree)adaptor.BecomeRoot(stream_ASSIGN.NextNode(), root_1);

                    	    adaptor.AddChild(root_1, stream_IDENTIFIER.NextNode());
                    	    adaptor.AddChild(root_1, stream_expr.NextTree());

                    	    adaptor.AddChild(root_0, root_1);
                    	    }

                    	}

                    	retval.Tree = root_0;retval.Tree = root_0;
                    }
                    break;

            }
            retval.Stop = input.LT(-1);

            	retval.Tree = (CommonTree)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, (IToken) retval.Start, (IToken) retval.Stop);
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
    	// Conversion of the second argument necessary, but harmless
    	retval.Tree = (CommonTree)adaptor.ErrorNode(input, (IToken) retval.Start, input.LT(-1), re);

        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end "expr"

    public class multExpr_return : ParserRuleReturnScope
    {
        private CommonTree tree;
        override public object Tree
        {
        	get { return tree; }
        	set { tree = (CommonTree) value; }
        }
    };

    // $ANTLR start "multExpr"
    // MyL.g:53:1: multExpr : unaryExpr ( ( MULTIPLY | DIVIDE ) unaryExpr )* ;
    public MyLParser.multExpr_return multExpr() // throws RecognitionException [1]
    {   
        MyLParser.multExpr_return retval = new MyLParser.multExpr_return();
        retval.Start = input.LT(1);

        CommonTree root_0 = null;

        IToken set11 = null;
        MyLParser.unaryExpr_return unaryExpr10 = null;

        MyLParser.unaryExpr_return unaryExpr12 = null;


        CommonTree set11_tree=null;

        try 
    	{
            // MyL.g:53:10: ( unaryExpr ( ( MULTIPLY | DIVIDE ) unaryExpr )* )
            // MyL.g:53:12: unaryExpr ( ( MULTIPLY | DIVIDE ) unaryExpr )*
            {
            	root_0 = (CommonTree)adaptor.GetNilNode();

            	PushFollow(FOLLOW_unaryExpr_in_multExpr186);
            	unaryExpr10 = unaryExpr();
            	state.followingStackPointer--;

            	adaptor.AddChild(root_0, unaryExpr10.Tree);
            	// MyL.g:53:22: ( ( MULTIPLY | DIVIDE ) unaryExpr )*
            	do 
            	{
            	    int alt3 = 2;
            	    int LA3_0 = input.LA(1);

            	    if ( ((LA3_0 >= MULTIPLY && LA3_0 <= DIVIDE)) )
            	    {
            	        alt3 = 1;
            	    }


            	    switch (alt3) 
            		{
            			case 1 :
            			    // MyL.g:53:23: ( MULTIPLY | DIVIDE ) unaryExpr
            			    {
            			    	set11=(IToken)input.LT(1);
            			    	set11 = (IToken)input.LT(1);
            			    	if ( (input.LA(1) >= MULTIPLY && input.LA(1) <= DIVIDE) ) 
            			    	{
            			    	    input.Consume();
            			    	    root_0 = (CommonTree)adaptor.BecomeRoot((CommonTree)adaptor.Create(set11), root_0);
            			    	    state.errorRecovery = false;
            			    	}
            			    	else 
            			    	{
            			    	    MismatchedSetException mse = new MismatchedSetException(null,input);
            			    	    throw mse;
            			    	}

            			    	PushFollow(FOLLOW_unaryExpr_in_multExpr196);
            			    	unaryExpr12 = unaryExpr();
            			    	state.followingStackPointer--;

            			    	adaptor.AddChild(root_0, unaryExpr12.Tree);

            			    }
            			    break;

            			default:
            			    goto loop3;
            	    }
            	} while (true);

            	loop3:
            		;	// Stops C# compiler whining that label 'loop3' has no statements


            }

            retval.Stop = input.LT(-1);

            	retval.Tree = (CommonTree)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, (IToken) retval.Start, (IToken) retval.Stop);
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
    	// Conversion of the second argument necessary, but harmless
    	retval.Tree = (CommonTree)adaptor.ErrorNode(input, (IToken) retval.Start, input.LT(-1), re);

        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end "multExpr"

    public class unaryExpr_return : ParserRuleReturnScope
    {
        private CommonTree tree;
        override public object Tree
        {
        	get { return tree; }
        	set { tree = (CommonTree) value; }
        }
    };

    // $ANTLR start "unaryExpr"
    // MyL.g:56:1: unaryExpr : ( PLUS primary -> ^( UNARY_PLUS primary ) | MINUS primary -> ^( UNARY_MINUS primary ) | primary );
    public MyLParser.unaryExpr_return unaryExpr() // throws RecognitionException [1]
    {   
        MyLParser.unaryExpr_return retval = new MyLParser.unaryExpr_return();
        retval.Start = input.LT(1);

        CommonTree root_0 = null;

        IToken PLUS13 = null;
        IToken MINUS15 = null;
        MyLParser.primary_return primary14 = null;

        MyLParser.primary_return primary16 = null;

        MyLParser.primary_return primary17 = null;


        CommonTree PLUS13_tree=null;
        CommonTree MINUS15_tree=null;
        RewriteRuleTokenStream stream_PLUS = new RewriteRuleTokenStream(adaptor,"token PLUS");
        RewriteRuleTokenStream stream_MINUS = new RewriteRuleTokenStream(adaptor,"token MINUS");
        RewriteRuleSubtreeStream stream_primary = new RewriteRuleSubtreeStream(adaptor,"rule primary");
        try 
    	{
            // MyL.g:56:11: ( PLUS primary -> ^( UNARY_PLUS primary ) | MINUS primary -> ^( UNARY_MINUS primary ) | primary )
            int alt4 = 3;
            switch ( input.LA(1) ) 
            {
            case PLUS:
            	{
                alt4 = 1;
                }
                break;
            case MINUS:
            	{
                alt4 = 2;
                }
                break;
            case IDENTIFIER:
            case NUMBER:
            case LPAREN:
            	{
                alt4 = 3;
                }
                break;
            	default:
            	    NoViableAltException nvae_d4s0 =
            	        new NoViableAltException("", 4, 0, input);

            	    throw nvae_d4s0;
            }

            switch (alt4) 
            {
                case 1 :
                    // MyL.g:56:13: PLUS primary
                    {
                    	PLUS13=(IToken)Match(input,PLUS,FOLLOW_PLUS_in_unaryExpr210);  
                    	stream_PLUS.Add(PLUS13);

                    	PushFollow(FOLLOW_primary_in_unaryExpr212);
                    	primary14 = primary();
                    	state.followingStackPointer--;

                    	stream_primary.Add(primary14.Tree);


                    	// AST REWRITE
                    	// elements:          primary
                    	// token labels:      
                    	// rule labels:       retval
                    	// token list labels: 
                    	// rule list labels:  
                    	retval.Tree = root_0;
                    	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));

                    	root_0 = (CommonTree)adaptor.GetNilNode();
                    	// 56:26: -> ^( UNARY_PLUS primary )
                    	{
                    	    // MyL.g:56:29: ^( UNARY_PLUS primary )
                    	    {
                    	    CommonTree root_1 = (CommonTree)adaptor.GetNilNode();
                    	    root_1 = (CommonTree)adaptor.BecomeRoot((CommonTree)adaptor.Create(UNARY_PLUS, "UNARY_PLUS"), root_1);

                    	    adaptor.AddChild(root_1, stream_primary.NextTree());

                    	    adaptor.AddChild(root_0, root_1);
                    	    }

                    	}

                    	retval.Tree = root_0;retval.Tree = root_0;
                    }
                    break;
                case 2 :
                    // MyL.g:57:6: MINUS primary
                    {
                    	MINUS15=(IToken)Match(input,MINUS,FOLLOW_MINUS_in_unaryExpr228);  
                    	stream_MINUS.Add(MINUS15);

                    	PushFollow(FOLLOW_primary_in_unaryExpr230);
                    	primary16 = primary();
                    	state.followingStackPointer--;

                    	stream_primary.Add(primary16.Tree);


                    	// AST REWRITE
                    	// elements:          primary
                    	// token labels:      
                    	// rule labels:       retval
                    	// token list labels: 
                    	// rule list labels:  
                    	retval.Tree = root_0;
                    	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));

                    	root_0 = (CommonTree)adaptor.GetNilNode();
                    	// 57:20: -> ^( UNARY_MINUS primary )
                    	{
                    	    // MyL.g:57:23: ^( UNARY_MINUS primary )
                    	    {
                    	    CommonTree root_1 = (CommonTree)adaptor.GetNilNode();
                    	    root_1 = (CommonTree)adaptor.BecomeRoot((CommonTree)adaptor.Create(UNARY_MINUS, "UNARY_MINUS"), root_1);

                    	    adaptor.AddChild(root_1, stream_primary.NextTree());

                    	    adaptor.AddChild(root_0, root_1);
                    	    }

                    	}

                    	retval.Tree = root_0;retval.Tree = root_0;
                    }
                    break;
                case 3 :
                    // MyL.g:58:6: primary
                    {
                    	root_0 = (CommonTree)adaptor.GetNilNode();

                    	PushFollow(FOLLOW_primary_in_unaryExpr246);
                    	primary17 = primary();
                    	state.followingStackPointer--;

                    	adaptor.AddChild(root_0, primary17.Tree);

                    }
                    break;

            }
            retval.Stop = input.LT(-1);

            	retval.Tree = (CommonTree)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, (IToken) retval.Start, (IToken) retval.Stop);
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
    	// Conversion of the second argument necessary, but harmless
    	retval.Tree = (CommonTree)adaptor.ErrorNode(input, (IToken) retval.Start, input.LT(-1), re);

        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end "unaryExpr"

    public class primary_return : ParserRuleReturnScope
    {
        private CommonTree tree;
        override public object Tree
        {
        	get { return tree; }
        	set { tree = (CommonTree) value; }
        }
    };

    // $ANTLR start "primary"
    // MyL.g:61:1: primary : ( NUMBER | IDENTIFIER | LPAREN expr RPAREN );
    public MyLParser.primary_return primary() // throws RecognitionException [1]
    {   
        MyLParser.primary_return retval = new MyLParser.primary_return();
        retval.Start = input.LT(1);

        CommonTree root_0 = null;

        IToken NUMBER18 = null;
        IToken IDENTIFIER19 = null;
        IToken LPAREN20 = null;
        IToken RPAREN22 = null;
        MyLParser.expr_return expr21 = null;


        CommonTree NUMBER18_tree=null;
        CommonTree IDENTIFIER19_tree=null;
        CommonTree LPAREN20_tree=null;
        CommonTree RPAREN22_tree=null;

        try 
    	{
            // MyL.g:61:10: ( NUMBER | IDENTIFIER | LPAREN expr RPAREN )
            int alt5 = 3;
            switch ( input.LA(1) ) 
            {
            case NUMBER:
            	{
                alt5 = 1;
                }
                break;
            case IDENTIFIER:
            	{
                alt5 = 2;
                }
                break;
            case LPAREN:
            	{
                alt5 = 3;
                }
                break;
            	default:
            	    NoViableAltException nvae_d5s0 =
            	        new NoViableAltException("", 5, 0, input);

            	    throw nvae_d5s0;
            }

            switch (alt5) 
            {
                case 1 :
                    // MyL.g:61:12: NUMBER
                    {
                    	root_0 = (CommonTree)adaptor.GetNilNode();

                    	NUMBER18=(IToken)Match(input,NUMBER,FOLLOW_NUMBER_in_primary260); 
                    		NUMBER18_tree = (CommonTree)adaptor.Create(NUMBER18);
                    		adaptor.AddChild(root_0, NUMBER18_tree);


                    }
                    break;
                case 2 :
                    // MyL.g:62:6: IDENTIFIER
                    {
                    	root_0 = (CommonTree)adaptor.GetNilNode();

                    	IDENTIFIER19=(IToken)Match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_primary267); 
                    		IDENTIFIER19_tree = (CommonTree)adaptor.Create(IDENTIFIER19);
                    		adaptor.AddChild(root_0, IDENTIFIER19_tree);


                    }
                    break;
                case 3 :
                    // MyL.g:63:6: LPAREN expr RPAREN
                    {
                    	root_0 = (CommonTree)adaptor.GetNilNode();

                    	LPAREN20=(IToken)Match(input,LPAREN,FOLLOW_LPAREN_in_primary274); 
                    	PushFollow(FOLLOW_expr_in_primary277);
                    	expr21 = expr();
                    	state.followingStackPointer--;

                    	adaptor.AddChild(root_0, expr21.Tree);
                    	RPAREN22=(IToken)Match(input,RPAREN,FOLLOW_RPAREN_in_primary279); 

                    }
                    break;

            }
            retval.Stop = input.LT(-1);

            	retval.Tree = (CommonTree)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, (IToken) retval.Start, (IToken) retval.Stop);
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
    	// Conversion of the second argument necessary, but harmless
    	retval.Tree = (CommonTree)adaptor.ErrorNode(input, (IToken) retval.Start, input.LT(-1), re);

        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end "primary"

    // Delegated rules


	private void InitializeCyclicDFAs()
	{
	}

 

    public static readonly BitSet FOLLOW_expr_in_program120 = new BitSet(new ulong[]{0x0000000000000400UL});
    public static readonly BitSet FOLLOW_NEWLINE_in_program122 = new BitSet(new ulong[]{0x0000000000000000UL});
    public static readonly BitSet FOLLOW_EOF_in_program125 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_multExpr_in_expr140 = new BitSet(new ulong[]{0x0000000000000032UL});
    public static readonly BitSet FOLLOW_set_in_expr143 = new BitSet(new ulong[]{0x0000000000006830UL});
    public static readonly BitSet FOLLOW_multExpr_in_expr150 = new BitSet(new ulong[]{0x0000000000000032UL});
    public static readonly BitSet FOLLOW_IDENTIFIER_in_expr159 = new BitSet(new ulong[]{0x0000000000001000UL});
    public static readonly BitSet FOLLOW_ASSIGN_in_expr161 = new BitSet(new ulong[]{0x0000000000006830UL});
    public static readonly BitSet FOLLOW_expr_in_expr163 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_unaryExpr_in_multExpr186 = new BitSet(new ulong[]{0x00000000000000C2UL});
    public static readonly BitSet FOLLOW_set_in_multExpr189 = new BitSet(new ulong[]{0x0000000000006830UL});
    public static readonly BitSet FOLLOW_unaryExpr_in_multExpr196 = new BitSet(new ulong[]{0x00000000000000C2UL});
    public static readonly BitSet FOLLOW_PLUS_in_unaryExpr210 = new BitSet(new ulong[]{0x0000000000006830UL});
    public static readonly BitSet FOLLOW_primary_in_unaryExpr212 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_MINUS_in_unaryExpr228 = new BitSet(new ulong[]{0x0000000000006830UL});
    public static readonly BitSet FOLLOW_primary_in_unaryExpr230 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_primary_in_unaryExpr246 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_NUMBER_in_primary260 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_IDENTIFIER_in_primary267 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_LPAREN_in_primary274 = new BitSet(new ulong[]{0x0000000000006830UL});
    public static readonly BitSet FOLLOW_expr_in_primary277 = new BitSet(new ulong[]{0x0000000000008000UL});
    public static readonly BitSet FOLLOW_RPAREN_in_primary279 = new BitSet(new ulong[]{0x0000000000000002UL});

}
}