﻿using System.Collections.Generic;
using Microsoft.Scripting.Ast;

namespace MyL.Parser.AST {

	class MyLSymbolTable {

		private static MyLScope _globalScope;
		public static MyLScope GlobalScope {
			get { return MyLSymbolTable._globalScope; }
		}

		public static void Initialize () {

			_globalScope = new MyLScope("Global");
		}

		public static Expression LookupName (string name) {

			return _globalScope.LookupName(name);

		}

		public static Expression GetOrMakeGlobal (string name) {

			return _globalScope.GetOrMakeGlobal(name, typeof(object));
		}

	}
}
